/**
 * Copyright (C) 2019 Patrik Dufresne Service Logiciel <info@patrikdufresne.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package com.planimod.ui.viewers;

import org.eclipse.core.databinding.conversion.Converter;
import org.eclipse.core.databinding.conversion.IConverter;

import com.planimod.core.Employee;

public class EmployeeViewerUtils {
    /**
     * This function may be used to display the employee name (combined).
     * 
     * @param e
     * @return
     */
    public static String getName(Employee employee) {
        String name = "";
        if (employee.getFirstname() != null) {
            name += employee.getFirstname();
        }
        if (employee.getLastname() != null) {
            if (employee.getFirstname() != null) {
                name += " ";
            }
            name += employee.getLastname();
        }
        return name.trim();
    }

    /**
     * Create a new converter to convert an employee object into a string. This implementation return the employee's
     * fullname.
     * 
     * @return the converter
     */
    public static IConverter fullnameConverter() {
        return new Converter(Employee.class, String.class) {
            @Override
            public Object convert(Object fromObject) {
                if (fromObject == null) {
                    return "";
                }
                return getName((Employee) fromObject);
            }
        };
    }

}
